<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRowDetailsTypeAirSeat ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfRowDetailsTypeAirSeat extends AbstractStructArrayBase
{
    /**
     * The AirSeat
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgRowDetailsTypeAirSeat[]
     */
    public $AirSeat;
    /**
     * Constructor method for ArrayOfRowDetailsTypeAirSeat
     * @uses DgArrayOfRowDetailsTypeAirSeat::setAirSeat()
     * @param \dgsoft\StructType\DgRowDetailsTypeAirSeat[] $airSeat
     */
    public function __construct(array $airSeat = array())
    {
        $this
            ->setAirSeat($airSeat);
    }
    /**
     * Get AirSeat value
     * @return \dgsoft\StructType\DgRowDetailsTypeAirSeat[]|null
     */
    public function getAirSeat()
    {
        return $this->AirSeat;
    }
    /**
     * Set AirSeat value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgRowDetailsTypeAirSeat[] $airSeat
     * @return \dgsoft\ArrayType\DgArrayOfRowDetailsTypeAirSeat
     */
    public function setAirSeat(array $airSeat = array())
    {
        foreach ($airSeat as $arrayOfRowDetailsTypeAirSeatAirSeatItem) {
            // validation for constraint: itemType
            if (!$arrayOfRowDetailsTypeAirSeatAirSeatItem instanceof \dgsoft\StructType\DgRowDetailsTypeAirSeat) {
                throw new \InvalidArgumentException(sprintf('The AirSeat property can only contain items of \dgsoft\StructType\DgRowDetailsTypeAirSeat, "%s" given', is_object($arrayOfRowDetailsTypeAirSeatAirSeatItem) ? get_class($arrayOfRowDetailsTypeAirSeatAirSeatItem) : gettype($arrayOfRowDetailsTypeAirSeatAirSeatItem)), __LINE__);
            }
        }
        $this->AirSeat = $airSeat;
        return $this;
    }
    /**
     * Add item to AirSeat value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgRowDetailsTypeAirSeat $item
     * @return \dgsoft\ArrayType\DgArrayOfRowDetailsTypeAirSeat
     */
    public function addToAirSeat(\dgsoft\StructType\DgRowDetailsTypeAirSeat $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgRowDetailsTypeAirSeat) {
            throw new \InvalidArgumentException(sprintf('The AirSeat property can only contain items of \dgsoft\StructType\DgRowDetailsTypeAirSeat, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->AirSeat[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgRowDetailsTypeAirSeat|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgRowDetailsTypeAirSeat|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgRowDetailsTypeAirSeat|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgRowDetailsTypeAirSeat|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgRowDetailsTypeAirSeat|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AirSeat
     */
    public function getAttributeName()
    {
        return 'AirSeat';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfRowDetailsTypeAirSeat
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
